/// <reference types="node" />
import { Spawn } from '../interfaces/spawn';
import { SpawnOptions, ChildProcess, SpawnSyncReturns } from 'child_process';
import { CommandUtil } from '../interfaces/command-util';
import { ForceErrorImpl } from "./force-error-impl";
export declare class SpawnImpl extends ForceErrorImpl implements Spawn {
    cachedPassword: string;
    commandUtil: CommandUtil;
    constructor(_commandUtil: CommandUtil);
    spawnShellCommandSync(cmd: string[], options?: SpawnOptions, cb?: (err: Error, spawnSyncReturns: SpawnSyncReturns<Buffer>) => void): SpawnSyncReturns<Buffer>;
    spawnShellCommandAsync(cmd: string[], options?: SpawnOptions, cbStatusOrFinal?: (err: Error, result: string) => void, cbFinal?: (err: Error, result: string) => void): ChildProcess;
    private childCloseOrExit(code, signal, result, cbFinal);
    sudoSpawnAsync(cmd: string[], options?: SpawnOptions, cbStatusOrFinal?: (err: Error, result: string) => void, cbFinal?: (err: Error, result: string) => void): ChildProcess;
}
