"use strict";
require('reflect-metadata');
const inversify_config_1 = require('../inversify.config');
const chai_1 = require('chai');
describe('Sudo', function () {
    let spawn;
    beforeEach(done => {
        spawn = inversify_config_1.default.get('Spawn');
        spawn.commandUtil.quiet = true;
        done();
    });
    afterEach(done => {
        spawn = null;
        done();
    });
    describe('spawnShellCommandAsync (force error)', () => {
        it('should report error', done => {
            chai_1.expect(spawn).to.not.equal(null);
            spawn.forceError = true;
            spawn.sudoSpawnAsync(['node', '/home/jreeme/src/firmament-yargs/js/test/test-00.js'], null, (err, result) => {
                chai_1.expect(result).to.equal(null);
                chai_1.expect(err).to.not.equal(null);
                chai_1.expect(err.message).to.equal('force error: spawnShellCommandAsync');
                done();
            });
        });
    });
});
//# sourceMappingURL=spawn-sudo.test.js.map