"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var inversify_1 = require("inversify");
var CommandUtilImpl = (function () {
    function CommandUtilImpl() {
        this._console = {
            log: this.stdoutLog,
            error: this.stdoutLog
        };
        this.quiet = false;
    }
    //noinspection JSUnusedLocalSymbols
    CommandUtilImpl.prototype.dummyLog = function (msg) {
    };
    CommandUtilImpl.prototype.stdoutLog = function (msg) {
        //console.log(msg);
        process.stdout.write(msg + "\n");
    };
    Object.defineProperty(CommandUtilImpl.prototype, "quiet", {
        set: function (beQuiet) {
            this._console.log = (beQuiet) ? this.dummyLog : this.stdoutLog;
            this._console.error = (beQuiet) ? this.dummyLog : this.stdoutLog;
        },
        enumerable: true,
        configurable: true
    });
    CommandUtilImpl.prototype.returnErrorStringOrMessage = function (err, message) {
        var errorMessage = this.logError(err, false);
        return errorMessage.length ? errorMessage : message;
    };
    CommandUtilImpl.prototype.error = function (msg) {
        this._console.error(msg);
    };
    CommandUtilImpl.prototype.log = function (msg) {
        this._console.log(msg);
    };
    CommandUtilImpl.prototype.logErrors = function (errs, writeErrorToConsole) {
        var _this = this;
        if (writeErrorToConsole === void 0) { writeErrorToConsole = true; }
        var retVal = [];
        errs.forEach(function (err) {
            retVal.push(_this.logError(err, writeErrorToConsole));
        });
        return retVal;
    };
    CommandUtilImpl.prototype.logError = function (err, writeErrorToConsole) {
        if (writeErrorToConsole === void 0) { writeErrorToConsole = true; }
        if (err) {
            if (writeErrorToConsole) {
                this._console.error(err.message);
            }
            return err.message;
        }
        return '';
    };
    CommandUtilImpl.prototype.processExitWithError = function (err, nonErrorMessage) {
        if (nonErrorMessage === void 0) { nonErrorMessage = null; }
        this.processExit(!!err ? 1 : 0, !!err ? err.message : !!nonErrorMessage ? nonErrorMessage : '');
    };
    CommandUtilImpl.prototype.processExit = function (exitCode, msg) {
        if (exitCode === void 0) { exitCode = 0; }
        if (msg === void 0) { msg = null; }
        this._console.log(!!msg ? msg : '');
        process.exit(exitCode);
    };
    CommandUtilImpl.prototype.callbackIfError = function (cb, err, result) {
        if (err === void 0) { err = null; }
        if (result === void 0) { result = null; }
        if (this.logError(err)) {
            if (cb && (typeof cb === 'function')) {
                cb(err, result);
            }
            //return 'true' if (err !== null)
            return true;
        }
        return false;
    };
    CommandUtilImpl.prototype.logAndCallback = function (msg, cb, err, result) {
        if (err === void 0) { err = null; }
        if (result === void 0) { result = null; }
        this._console.log(err ? err.message : msg);
        if (cb && (typeof cb === 'function')) {
            cb(err, result);
        }
        return !!err;
    };
    CommandUtilImpl = __decorate([
        inversify_1.injectable()
    ], CommandUtilImpl);
    return CommandUtilImpl;
}());
exports.CommandUtilImpl = CommandUtilImpl;
